/*
 * Sistemas de Telecomunicações 
 *          2012/2013
 */
package udpdemoproject;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;

/**
 *
 * @author lflb@fct.unl.pt
 */
public class Daemon_udp extends Thread {

    volatile boolean keepRunning = true;
    Chat_udp root;                        // Main window object
    DatagramSocket ds;                    // datagram socket

    public Daemon_udp(Chat_udp root, DatagramSocket ds) {
        this.root = root;
        this.ds = ds;
    }

    @Override
    public void run() {
        byte[] buf = new byte[Chat_udp.MAX_PLENGTH];
        DatagramPacket dp = new DatagramPacket(buf, buf.length);
        try {
            while (keepRunning) {
                try {
                    ds.receive(dp);    // Wait for packets
                    ByteArrayInputStream BAis =
                            new ByteArrayInputStream(buf, 0, dp.getLength());
                    DataInputStream dis = new DataInputStream(BAis);
                    // process packet in Chat_udp object
                    root.receive_packet(dp, dis); 
                } catch (SocketException se) {
                    if (keepRunning) {
                        root.Log_rem("recv UDP SocketException : " + se + "\n");
                    }
                }
            }
        } catch (IOException e) {
            if (keepRunning) {
                root.Log_rem("IO exception receiving data from socket : " + e);
            }
        }
    }

    public void stopRunning() {
        keepRunning = false;
    }
}
